package org.dromara.payment.channel.service;

import org.dromara.payment.channel.domain.BusChannelAccount;
import org.dromara.payment.channel.domain.vo.BusChannelAccountVo;
import org.dromara.payment.channel.domain.bo.BusChannelAccountBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.payment.merchant.domain.vo.BusMerchantAccountVo;

import java.util.Collection;
import java.util.List;

/**
 * 代理商账户Service接口
 *
 * @author LionLi
 * @date 2024-04-10
 */
public interface IBusChannelAccountService {

    /**
     * 查询代理商账户
     */
    BusChannelAccountVo queryById(Long id);

    /**
     * 查询代理商账户列表
     */
    TableDataInfo<BusChannelAccountVo> queryPageList(BusChannelAccountBo bo, PageQuery pageQuery);

    /**
     * 查询代理商账户列表
     */
    List<BusChannelAccountVo> queryList(BusChannelAccountBo bo);

    /**
     * 新增代理商账户
     */
    Boolean insertByBo(BusChannelAccountBo bo);

    /**
     * 修改代理商账户
     */
    Boolean updateByBo(BusChannelAccountBo bo);

    /**
     * 校验并批量删除代理商账户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalance(long unitId,long amount);

    /**
     * 递增或递减账户冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozen(long unitId,long amount);

    /**
     * 查询代理商提现账户信息
     * @param id 资金账户id
     * @return
     */
    public BusChannelAccountVo getCashoutAccount(Long id);
}
